'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var AwaitExpression = (function (_Expression) {
    _inherits(AwaitExpression, _Expression);

    // TODO: Requires an async function.

    function AwaitExpression(childNodes) {
        _classCallCheck(this, AwaitExpression);

        _get(Object.getPrototypeOf(AwaitExpression.prototype), 'constructor', this).call(this, 'AwaitExpression', childNodes);
    }

    _createClass(AwaitExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            children.passToken('Identifier', 'await');

            var argument = null;

            if (!children.isEnd) {
                children.skipNonCode();
                argument = children.passExpression();
            }

            children.assertEnd();

            this._argument = argument;
        }
    }, {
        key: 'argument',
        get: function get() {
            return this._argument;
        }
    }]);

    return AwaitExpression;
})(_Expression3['default']);

exports['default'] = AwaitExpression;
module.exports = exports['default'];