'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Statement2 = require('../Statement');

var _Statement3 = _interopRequireDefault(_Statement2);

var ForOfStatement = (function (_Statement) {
    _inherits(ForOfStatement, _Statement);

    function ForOfStatement(childNodes) {
        _classCallCheck(this, ForOfStatement);

        _get(Object.getPrototypeOf(ForOfStatement.prototype), 'constructor', this).call(this, 'ForOfStatement', childNodes);
    }

    _createClass(ForOfStatement, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            children.passToken('Keyword', 'for');
            children.skipNonCode();

            children.passToken('Punctuator', '(');
            children.skipNonCode();

            var left = undefined;
            if (children.isNode('VariableDeclaration')) {
                left = children.currentElement;
                children.moveNext();
            } else {
                left = children.passAssignable();
            }
            children.skipNonCode();

            children.passToken('Identifier', 'of');
            children.skipNonCode();

            var right = children.passExpression();
            children.skipNonCode();

            children.passToken('Punctuator', ')');
            children.skipNonCode();

            var body = children.passStatement();

            children.assertEnd();

            this._left = left;
            this._right = right;
            this._body = body;
        }
    }, {
        key: 'left',
        get: function get() {
            return this._left;
        }
    }, {
        key: 'right',
        get: function get() {
            return this._right;
        }
    }, {
        key: 'body',
        get: function get() {
            return this._body;
        }
    }, {
        key: 'each',
        get: function get() {
            return false;
        }
    }]);

    return ForOfStatement;
})(_Statement3['default']);

exports['default'] = ForOfStatement;
module.exports = exports['default'];