'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _ModuleSpecifier2 = require('../ModuleSpecifier');

var _ModuleSpecifier3 = _interopRequireDefault(_ModuleSpecifier2);

// tests are in ImportDeclaration

var ImportSpecifier = (function (_ModuleSpecifier) {
    _inherits(ImportSpecifier, _ModuleSpecifier);

    function ImportSpecifier(childNodes) {
        _classCallCheck(this, ImportSpecifier);

        _get(Object.getPrototypeOf(ImportSpecifier.prototype), 'constructor', this).call(this, 'ImportSpecifier', childNodes);
    }

    _createClass(ImportSpecifier, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var local = undefined;
            var imported = children.passNode('Identifier');

            if (!children.isEnd) {
                children.skipNonCode();
                children.passToken('Identifier', 'as');
                children.skipNonCode();
                local = children.passNode('Identifier');
            } else {
                local = imported;
            }

            children.assertEnd();

            this._local = local;
            this._imported = imported;
        }
    }, {
        key: 'imported',
        get: function get() {
            return this._imported;
        }
    }]);

    return ImportSpecifier;
})(_ModuleSpecifier3['default']);

exports['default'] = ImportSpecifier;
module.exports = exports['default'];