'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Statement2 = require('../Statement');

var _Statement3 = _interopRequireDefault(_Statement2);

var LabeledStatement = (function (_Statement) {
    _inherits(LabeledStatement, _Statement);

    function LabeledStatement(childNodes) {
        _classCallCheck(this, LabeledStatement);

        _get(Object.getPrototypeOf(LabeledStatement.prototype), 'constructor', this).call(this, 'LabeledStatement', childNodes);
    }

    _createClass(LabeledStatement, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var label = children.passNode('Identifier');
            children.skipNonCode();

            children.passToken('Punctuator', ':');
            children.skipNonCode();

            var body = children.passStatement();

            children.assertEnd();

            this._label = label;
            this._body = body;
        }
    }, {
        key: 'label',
        get: function get() {
            return this._label;
        }
    }, {
        key: 'body',
        get: function get() {
            return this._body;
        }
    }]);

    return LabeledStatement;
})(_Statement3['default']);

exports['default'] = LabeledStatement;
module.exports = exports['default'];