'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var logicalOperators = {
    '||': true,
    '&&': true
};

var LogicalExpression = (function (_Expression) {
    _inherits(LogicalExpression, _Expression);

    // TODO: Should respect operator precedence: putting "a + b" before " * b" without parens should raise an error.

    function LogicalExpression(childNodes) {
        _classCallCheck(this, LogicalExpression);

        _get(Object.getPrototypeOf(LogicalExpression.prototype), 'constructor', this).call(this, 'LogicalExpression', childNodes);
    }

    _createClass(LogicalExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var left = children.passExpression();
            children.skipNonCode();

            var operator = children.passToken('Punctuator', logicalOperators).value;
            children.skipNonCode();

            var right = children.passExpression();
            children.assertEnd();

            this._left = left;
            this._operator = operator;
            this._right = right;
        }
    }, {
        key: 'left',
        get: function get() {
            return this._left;
        }
    }, {
        key: 'right',
        get: function get() {
            return this._right;
        }
    }, {
        key: 'operator',
        get: function get() {
            return this._operator;
        }
    }]);

    return LogicalExpression;
})(_Expression3['default']);

exports['default'] = LogicalExpression;
module.exports = exports['default'];