'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var MemberExpression = (function (_Expression) {
    _inherits(MemberExpression, _Expression);

    function MemberExpression(childNodes) {
        _classCallCheck(this, MemberExpression);

        _get(Object.getPrototypeOf(MemberExpression.prototype), 'constructor', this).call(this, 'MemberExpression', childNodes);
    }

    _createClass(MemberExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var object = children.passExpressionOrSuper();
            children.skipNonCode();

            var property = undefined;
            var computed = false;
            if (children.isToken('Punctuator', '.')) {
                children.passToken();
                children.skipNonCode();

                property = children.passNode('Identifier');
                computed = false;
            } else {
                children.passToken('Punctuator', '[');
                children.skipNonCode();
                property = children.passExpression();
                children.skipNonCode();
                children.passToken('Punctuator', ']');
                computed = true;
            }

            children.assertEnd();

            this._object = object;
            this._property = property;
            this._computed = computed;
        }
    }, {
        key: 'object',
        get: function get() {
            return this._object;
        }
    }, {
        key: 'property',
        get: function get() {
            return this._property;
        }
    }, {
        key: 'computed',
        get: function get() {
            return this._computed;
        }
    }, {
        key: 'isAssignable',
        get: function get() {
            return true;
        }
    }]);

    return MemberExpression;
})(_Expression3['default']);

exports['default'] = MemberExpression;
module.exports = exports['default'];