'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var TaggedTemplateExpression = (function (_Expression) {
    _inherits(TaggedTemplateExpression, _Expression);

    function TaggedTemplateExpression(childNodes) {
        _classCallCheck(this, TaggedTemplateExpression);

        _get(Object.getPrototypeOf(TaggedTemplateExpression.prototype), 'constructor', this).call(this, 'TaggedTemplateExpression', childNodes);
    }

    _createClass(TaggedTemplateExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var tag = children.passExpression();
            children.skipNonCode();
            var quasi = children.passNode('TemplateLiteral');

            this._tag = tag;
            this._quasi = quasi;
        }
    }, {
        key: 'tag',
        get: function get() {
            return this._tag;
        }
    }, {
        key: 'quasi',
        get: function get() {
            return this._quasi;
        }
    }]);

    return TaggedTemplateExpression;
})(_Expression3['default']);

exports['default'] = TaggedTemplateExpression;
module.exports = exports['default'];