'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Node2 = require('../Node');

var _Node3 = _interopRequireDefault(_Node2);

var TemplateElement = (function (_Node) {
    _inherits(TemplateElement, _Node);

    function TemplateElement(childNodes) {
        _classCallCheck(this, TemplateElement);

        _get(Object.getPrototypeOf(TemplateElement.prototype), 'constructor', this).call(this, 'TemplateElement', childNodes);
    }

    _createClass(TemplateElement, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var templateToken = children.passToken('Template');

            var tail = false;
            var value = {
                cooked: templateToken.value,
                raw: templateToken.sourceCode
            };

            children.assertEnd();

            this._tail = tail;
            this._value = value;
        }
    }, {
        key: 'tail',
        get: function get() {
            return this._tail;
        },
        set: function set(bool) {
            this._tail = bool;
        }
    }, {
        key: 'value',
        get: function get() {
            return this._value;
        }
    }]);

    return TemplateElement;
})(_Node3['default']);

exports['default'] = TemplateElement;
module.exports = exports['default'];