'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _BasePlugin2 = require('../BasePlugin');

var _BasePlugin3 = _interopRequireDefault(_BasePlugin2);

var _ScopesApi = require('./ScopesApi');

var _ScopesApi2 = _interopRequireDefault(_ScopesApi);

var ScopesPlugin = (function (_BasePlugin) {
    _inherits(ScopesPlugin, _BasePlugin);

    function ScopesPlugin() {
        _classCallCheck(this, ScopesPlugin);

        _get(Object.getPrototypeOf(ScopesPlugin.prototype), 'constructor', this).apply(this, arguments);
    }

    _createClass(ScopesPlugin, [{
        key: 'createApiForProgram',
        value: function createApiForProgram(program) {
            return new _ScopesApi2['default'](program);
        }
    }, {
        key: 'pluginName',
        get: function get() {
            return 'scopes';
        }
    }]);

    return ScopesPlugin;
})(_BasePlugin3['default']);

exports['default'] = ScopesPlugin;
module.exports = exports['default'];