'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var CallExpression = (function (_Expression) {
    _inherits(CallExpression, _Expression);

    function CallExpression(childNodes) {
        _classCallCheck(this, CallExpression);

        _get(Object.getPrototypeOf(CallExpression.prototype), 'constructor', this).call(this, 'CallExpression', childNodes);
    }

    _createClass(CallExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var args = [];

            var callee = children.passExpressionOrSuper();
            children.skipNonCode();

            children.passToken('Punctuator', '(');
            children.skipNonCode();

            while (!children.isToken('Punctuator', ')')) {
                if (children.isToken('Punctuator', ',')) {
                    children.moveNext();
                    children.skipNonCode();
                    children.assertToken('Punctuator', ')');
                } else {
                    args.push(children.passExpressionOrSpreadElement());
                    children.skipNonCode();
                    if (children.isToken('Punctuator', ',')) {
                        children.moveNext();
                        children.skipNonCode();
                    }
                }
            }

            children.passToken('Punctuator', ')');
            children.assertEnd();

            this._callee = callee;
            this._arguments = args;
        }
    }, {
        key: 'arguments',
        get: function get() {
            return this._arguments.concat();
        }
    }, {
        key: 'callee',
        get: function get() {
            return this._callee;
        }
    }]);

    return CallExpression;
})(_Expression3['default']);

exports['default'] = CallExpression;
module.exports = exports['default'];