'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _ModuleDeclaration2 = require('../ModuleDeclaration');

var _ModuleDeclaration3 = _interopRequireDefault(_ModuleDeclaration2);

var ExportNamedDeclaration = (function (_ModuleDeclaration) {
    _inherits(ExportNamedDeclaration, _ModuleDeclaration);

    function ExportNamedDeclaration(childNodes) {
        _classCallCheck(this, ExportNamedDeclaration);

        _get(Object.getPrototypeOf(ExportNamedDeclaration.prototype), 'constructor', this).call(this, 'ExportNamedDeclaration', childNodes);
    }

    _createClass(ExportNamedDeclaration, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            children.passToken('Keyword', 'export');
            children.skipNonCode();

            var declaration = null;
            var specifiers = [];
            var source = null;

            if (children.isNode('VariableDeclaration') || children.isNode('FunctionDeclaration') || children.isNode('ClassDeclaration')) {
                declaration = children.passStatement();
            } else {
                // es2015 exports
                if (children.isToken('Punctuator', '{')) {
                    children.passToken('Punctuator', '{');
                    children.skipNonCode();
                    while (!children.isToken('Punctuator', '}')) {
                        specifiers.push(children.passModuleSpecifier());
                        children.skipNonCode();
                        if (children.isToken('Punctuator', ',')) {
                            children.moveNext();
                            children.skipNonCode();
                        }
                    }
                    children.passToken('Punctuator', '}');
                } else {
                    // es2016 export from
                    specifiers.push(children.passModuleSpecifier());
                }
                children.skipNonCode();

                if (children.isToken('Identifier', 'from')) {
                    children.passToken('Identifier', 'from');
                    children.skipNonCode();
                    source = children.passNode('Literal');
                    if (!children.isEnd) {
                        children.skipNonCode();
                        children.passToken('Punctuator', ';');
                    }
                } else if (!children.isEnd) {
                    children.passToken('Punctuator', ';');
                }
            }

            children.assertEnd();

            this._declaration = declaration;
            this._specifiers = specifiers;
            this._source = source;
        }
    }, {
        key: 'declaration',
        get: function get() {
            return this._declaration;
        }
    }, {
        key: 'specifiers',
        get: function get() {
            return this._specifiers;
        }
    }, {
        key: 'source',
        get: function get() {
            return this._source;
        }
    }]);

    return ExportNamedDeclaration;
})(_ModuleDeclaration3['default']);

exports['default'] = ExportNamedDeclaration;
module.exports = exports['default'];