'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Node2 = require('../Node');

var _Node3 = _interopRequireDefault(_Node2);

var getterAndSetter = {
    get: true,
    set: true
};

var MethodDefinition = (function (_Node) {
    _inherits(MethodDefinition, _Node);

    function MethodDefinition(childNodes) {
        _classCallCheck(this, MethodDefinition);

        _get(Object.getPrototypeOf(MethodDefinition.prototype), 'constructor', this).call(this, 'MethodDefinition', childNodes);
    }

    _createClass(MethodDefinition, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var key = undefined;
            var computed = undefined;
            var value = undefined;
            var kind = undefined;
            var staticMember = false;
            var generator = false;

            if (children.isToken('Identifier', 'static')) {
                staticMember = true;
                children.passToken();
                children.skipNonCode();
            }

            if (children.isToken('Identifier', getterAndSetter)) {
                kind = children.currentElement.value;
                children.passToken();
                children.skipNonCode();
            } else {
                kind = 'method';
                if (children.isToken('Punctuator', '*')) {
                    generator = true;
                    children.passToken();
                    children.skipNonCode();
                }
            }

            if (children.isNode('Identifier')) {
                computed = false;
                key = children.passNode();
                if (kind === 'method' && key.type === 'Identifier' && key.name === 'constructor') {
                    kind = 'constructor';
                }
                children.skipNonCode();
            } else {
                computed = true;
                children.passToken('Punctuator', '[');
                children.skipNonCode();
                key = children.passExpression();
                children.skipNonCode();
                children.passToken('Punctuator', ']');
                children.skipNonCode();
            }

            value = children.passNode('FunctionExpression');

            children.assertEnd();

            this._kind = kind;
            this._key = key;
            this._value = value;
            this._computed = computed;
            this._static = staticMember;
            this._generator = generator;
        }
    }, {
        key: 'key',
        get: function get() {
            return this._key;
        }
    }, {
        key: 'value',
        get: function get() {
            return this._value;
        }
    }, {
        key: 'kind',
        get: function get() {
            return this._kind;
        }
    }, {
        key: 'static',
        get: function get() {
            return this._static;
        }
    }, {
        key: 'computed',
        get: function get() {
            return this._computed;
        }
    }]);

    return MethodDefinition;
})(_Node3['default']);

exports['default'] = MethodDefinition;
module.exports = exports['default'];