'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var ObjectExpression = (function (_Expression) {
    _inherits(ObjectExpression, _Expression);

    function ObjectExpression(childNodes) {
        _classCallCheck(this, ObjectExpression);

        _get(Object.getPrototypeOf(ObjectExpression.prototype), 'constructor', this).call(this, 'ObjectExpression', childNodes);
    }

    _createClass(ObjectExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var properties = [];

            children.passToken('Punctuator', '{');
            children.skipNonCode();

            while (!children.isToken('Punctuator', '}')) {
                if (children.isToken('Punctuator', ',')) {
                    children.moveNext();
                    children.skipNonCode();
                    children.assertToken('Punctuator', '}');
                } else {
                    if (children.isNode('SpreadProperty')) {
                        properties.push(children.passNode('SpreadProperty'));
                    } else {
                        properties.push(children.passNode('Property'));
                    }
                    children.skipNonCode();
                    if (children.isToken('Punctuator', ',')) {
                        children.moveNext();
                        children.skipNonCode();
                    }
                }
            }

            children.passToken('Punctuator', '}');
            children.assertEnd();

            this._properties = properties;
        }
    }, {
        key: 'properties',
        get: function get() {
            return this._properties.concat();
        }
    }]);

    return ObjectExpression;
})(_Expression3['default']);

exports['default'] = ObjectExpression;
module.exports = exports['default'];