'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var SequenceExpression = (function (_Expression) {
    _inherits(SequenceExpression, _Expression);

    // TODO: Should respect operator precedence: putting "a + b" before " * b" without parens should raise an error.

    function SequenceExpression(childNodes) {
        _classCallCheck(this, SequenceExpression);

        _get(Object.getPrototypeOf(SequenceExpression.prototype), 'constructor', this).call(this, 'SequenceExpression', childNodes);
    }

    _createClass(SequenceExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var expressions = [];

            expressions.push(children.passExpression());
            children.skipNonCode();

            do {
                children.passToken('Punctuator', ',');
                children.skipNonCode();
                expressions.push(children.passExpression());
                children.skipNonCode();
            } while (!children.isEnd);

            children.assertEnd();

            this._expressions = expressions;
        }
    }, {
        key: 'expressions',
        get: function get() {
            return this._expressions.concat();
        }
    }]);

    return SequenceExpression;
})(_Expression3['default']);

exports['default'] = SequenceExpression;
module.exports = exports['default'];