'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Statement2 = require('../Statement');

var _Statement3 = _interopRequireDefault(_Statement2);

var TryStatement = (function (_Statement) {
    _inherits(TryStatement, _Statement);

    function TryStatement(childNodes) {
        _classCallCheck(this, TryStatement);

        _get(Object.getPrototypeOf(TryStatement.prototype), 'constructor', this).call(this, 'TryStatement', childNodes);
    }

    _createClass(TryStatement, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            children.passToken('Keyword', 'try');
            children.skipNonCode();

            var block = children.passStatement('BlockStatement');
            children.skipNonCode();

            var handler = null;
            if (children.isNode('CatchClause')) {
                handler = children.passNode();
            }

            var finalizer = null;
            if (!children.isEnd) {
                children.skipNonCode();
                children.passToken('Keyword', 'finally');
                children.skipNonCode();
                finalizer = children.passStatement('BlockStatement');
            }

            children.assertEnd();

            this._block = block;
            this._finalizer = finalizer;
            this._handler = handler;
        }
    }, {
        key: 'block',
        get: function get() {
            return this._block;
        }
    }, {
        key: 'handler',
        get: function get() {
            return this._handler;
        }
    }, {
        key: 'finalizer',
        get: function get() {
            return this._finalizer;
        }
    }]);

    return TryStatement;
})(_Statement3['default']);

exports['default'] = TryStatement;
module.exports = exports['default'];