'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Statement2 = require('../Statement');

var _Statement3 = _interopRequireDefault(_Statement2);

var validKinds = {
    'var': true,
    'let': true,
    'const': true
};

var VariableDeclaration = (function (_Statement) {
    _inherits(VariableDeclaration, _Statement);

    // TODO: Can only have 1 declarator inside for ... in.

    function VariableDeclaration(childNodes) {
        _classCallCheck(this, VariableDeclaration);

        _get(Object.getPrototypeOf(VariableDeclaration.prototype), 'constructor', this).call(this, 'VariableDeclaration', childNodes);
    }

    _createClass(VariableDeclaration, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            var kind = children.passToken('Keyword', validKinds).value;
            children.skipNonCode();

            var declarations = [];

            declarations.push(children.passNode('VariableDeclarator'));
            children.skipNonCode();

            while (children.isToken('Punctuator', ',')) {
                children.passToken();
                children.skipNonCode();
                declarations.push(children.passNode('VariableDeclarator'));
                children.skipNonCode();
            }

            children.skipSemicolon();
            children.assertEnd();

            this._kind = kind;
            this._declarations = declarations;
        }
    }, {
        key: 'kind',
        get: function get() {
            return this._kind;
        }
    }, {
        key: 'declarations',
        get: function get() {
            return this._declarations.concat();
        }
    }]);

    return VariableDeclaration;
})(_Statement3['default']);

exports['default'] = VariableDeclaration;
module.exports = exports['default'];