'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var YieldExpression = (function (_Expression) {
    _inherits(YieldExpression, _Expression);

    // TODO: Requires a generator function.

    function YieldExpression(childNodes) {
        _classCallCheck(this, YieldExpression);

        _get(Object.getPrototypeOf(YieldExpression.prototype), 'constructor', this).call(this, 'YieldExpression', childNodes);
    }

    _createClass(YieldExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            children.passToken('Keyword', 'yield');

            var argument = null;
            var delegate = false;

            if (!children.isEnd) {
                children.skipNonCode();

                if (children.isToken('Punctuator', '*')) {
                    children.passToken();
                    children.skipNonCode();
                    delegate = true;
                }

                argument = children.passExpression();
            }

            children.assertEnd();

            this._argument = argument;
            this._delegate = delegate;
        }
    }, {
        key: 'argument',
        get: function get() {
            return this._argument;
        }
    }, {
        key: 'delegate',
        get: function get() {
            return this._delegate;
        }
    }]);

    return YieldExpression;
})(_Expression3['default']);

exports['default'] = YieldExpression;
module.exports = exports['default'];